<?php

declare(strict_types=1);

namespace Dedi\SyliusSogenactifPlugin\Payum\Sogenactif\Action;

use Payum\Core\Action\ActionInterface;
use Sylius\Bundle\PayumBundle\Request\ResolveNextRoute as PayumResolveNextRoute;
use Sylius\Component\Core\Model\PaymentInterface;

final class ResolveNextRoute implements ActionInterface
{
    public function execute($request): void
    {
        /** @var PaymentInterface $payment */
        $payment = $request->getFirstModel();

        if (
            $payment->getState() === PaymentInterface::STATE_COMPLETED ||
            $payment->getState() === PaymentInterface::STATE_AUTHORIZED ||
            $payment->getState() === PaymentInterface::STATE_PROCESSING
        ) {
            $request->setRouteName(
                'sylius_shop_order_thank_you',
            );

            return;
        }

        $request->setRouteName('sylius_shop_order_show');
        $request->setRouteParameters(['tokenValue' => $payment->getOrder()->getTokenValue()]);
    }

    public function supports($request): bool
    {
        return
            $request instanceof PayumResolveNextRoute &&
            $request->getFirstModel() instanceof PaymentInterface
        ;
    }
}
